//
//  components.h
//  AC Circuits
//
//  Created by Brett Yang on 17/4/18.
//
//  Copyright © 2018 Brett Yang.
//  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
//  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//

#ifndef components_h
#define components_h

#include <iostream>
#include "complex.h"


using namespace std;

class component
{
public:
    virtual ~component() = default;
    virtual void set_frequency(const double freq)=0;
    virtual double get_frequency()=0;
    virtual complex get_impedance()=0;
    virtual double get_magnitudeimpedance()=0;
    virtual double get_phasedifference()=0;
    virtual string get_name()=0;
    virtual string get_type()=0;
    virtual double get_info()=0; // The return values are resistance, capacitance or inductance, depending on component type
    virtual void print_info()=0;
};


#endif /* components_h */
